package com.hc.gpbusiness.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hc.gpbusiness.model.WebQrCode;
import com.hc.gpbusiness.mapper.WebQrCodeMapper;
import com.hc.gpbusiness.service.WebQrCodeService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 官网二维码表(WebQrCode)表服务实现类
 *
 * @author makejava
 * @since 2024-11-21 14:29:52
 */

@Service("webQrCodeService")
public class WebQrCodeServiceImpl implements WebQrCodeService {

    private final WebQrCodeMapper webQrCodeMapper;

    public WebQrCodeServiceImpl(WebQrCodeMapper webQrCodeMapper) {
        this.webQrCodeMapper = webQrCodeMapper;
    }

    /**
     * 通过ID查询单条数据
     *
     * @param qrId 主键
     * @return 实例对象
     */
    @Override
    public WebQrCode queryById(Integer qrId) {
        return this.webQrCodeMapper.selectByPrimaryKey(qrId);
    }

    /**
     * 新增数据
     *
     * @param webQrCode 实例对象
     * @return 实例对象
     */
    @Override
    public WebQrCode insert(WebQrCode webQrCode) {
        this.webQrCodeMapper.insert(webQrCode);
        return webQrCode;
    }

    /**
     * 修改数据
     *
     * @param webQrCode 实例对象
     * @return 实例对象
     */
    @Override
    public WebQrCode update(WebQrCode webQrCode) {
        this.webQrCodeMapper.updateByPrimaryKeySelective(webQrCode);
        return this.queryById(webQrCode.getQrId());
    }

    /**
     * 通过主键删除数据
     *
     * @param qrId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer qrId) {
        return this.webQrCodeMapper.deleteByPrimaryKey(qrId) > 0;
    }

    /**
     * 分页查询多条数据
     *
     * @param page 页码
     * @param size 查询条数
     * @return 对象列表
     */
    @Override
    public PageInfo queryAllByLimit(int page, int size) {
        return PageHelper.startPage(page, size).doSelectPageInfo(this.webQrCodeMapper::selectAll);
    }

    @Override
    public PageInfo queryByAll(int page, int size,String qrName1,
                               String qrName2,
                               Integer qrType,
                               Integer qrId1,
                               Integer qrId2,String fileName) {
        return PageHelper.startPage(page, size).doSelectPageInfo(() -> this.webQrCodeMapper.queryByAll(qrName1,qrName2,qrType,qrId1,qrId2,fileName));
    }
}
